{% macro bubble_index(entry) %}
    {% set endpoint_hardlink= null %}
    {% set endpoint_fetch   = null %}
    {% set endpoint_spring  = null %}
    {% set endpoint_answer  = null %}
    {% set endpoint_trash   = null %}
    {% set endpoint_unread  = null %}
    {% set endpoint_users   = null %}
    {% set endpoint_block   = null %}
    {% set endpoint_block_n = null %}
    {% set endpoint_archive = null %}
    {% set endpoint_pin     = null %}
    {% set endpoint_unpin   = null %}
    {% set endpoint_restore = null %}
    {% set message_title_pre= null %}
    {% set message_title    = entry.title %}
    {% set message_id       = 0 %}
    {% set message_type     = 'un' %}
    {% set message_show_ava = true %}
    {% if entry.obj|instance_of('App\\Entity\\UserGroupAssociation') %}
        {% if not entry.closed %}
            {% set endpoint_answer = path('pm_post_editor_controller', {'id': entry.obj.association.id}) %}
            {% set endpoint_users  = path('pm_conv_group_users', {'id': entry.obj.association.id}) %}
            {% set endpoint_spring = path('api_pm_spring', {'id': entry.obj.association.id, 'domain': 'g'}) %}
        {% endif %}
        {% set endpoint_fetch  = path('pm_conv_group', {'id': entry.obj.association.id}) %}
        {% if entry.official is null %}
            {% set endpoint_trash  = path('pm_delete_conv_group', {'id': entry.obj.association.id}) %}
        {% endif %}
        {% set endpoint_unread = path('pm_unread_conv_group', {'id': entry.obj.association.id}) %}
        {% if entry.official is null and entry.owner is not null and entry.owner != app.user and not app.user|related(entry.owner,constant('App\\Entity\\SocialRelation::SocialRelationTypeBlock')) %}
            {% set endpoint_block   = path('pm_block_conv_group', {'id': entry.obj.association.id}) %}
            {% set endpoint_block_n = entry.owner.name %}
        {% endif %}
        {% if entry.archive %}
            {% set endpoint_restore = path('pm_archive_conv_group', {'id': entry.obj.association.id, 'arch': 0}) %}
        {% else %}
            {% set endpoint_archive = path('pm_archive_conv_group', {'id': entry.obj.association.id, 'arch': 1}) %}
        {% endif %}
        {% if entry.obj.priority > 0 %}
            {% set endpoint_unpin = path('pm_pin_conv_group', {'id': entry.obj.association.id, 'pin': 0}) %}
        {% else %}
            {% set endpoint_pin = path('pm_pin_conv_group', {'id': entry.obj.association.id, 'pin': 1}) %}
        {% endif %}
        {% set message_id      = entry.obj.id %}
        {% set message_type    = 'g' %}
    {% elseif entry.obj|instance_of('App\\Entity\\Announcement') %}
        {% set message_title    = 'Ankündigung'|trans({},'global') %}
        {% set endpoint_fetch   = path('pm_announce', {'id': entry.obj.id}) %}
        {% set endpoint_unread  = path('pm_unread_announce', {'id': entry.obj.id}) %}
        {% set message_id       = entry.obj.id %}
        {% set message_type     = 'a' %}
        {% set message_show_ava = false %}
    {% elseif entry.obj|instance_of('App\\Entity\\GlobalPrivateMessage') %}
        {% set endpoint_fetch  = path('pm_dm') %}
        {% set endpoint_spring = path('api_pm_spring', {'id': entry.owner.id, 'domain': 'd'}) %}
        {% set endpoint_trash  = path('pm_delete_dm') %}
        {% set endpoint_unread = path('pm_unread_dm') %}
        {% set message_id      = entry.owner.id %}
        {% set message_type    = 'd' %}
    {% elseif entry.obj|instance_of('App\\Entity\\Thread') %}
        {% set message_id        = entry.obj.id %}
        {% if entry.count <= 1 %}
            {% set message_title_pre = 'Neuer Beitrag in'|trans({},'global') %}
        {% elseif entry.count < 10 %}
            {% set message_title_pre = '{n} neue Beiträge in'|trans({n: entry.count},'global') %}
        {% else %}
            {% set message_title_pre = '{n} oder mehr neue Beiträge in'|trans({n: entry.count},'global') %}
        {% endif %}
        {% set endpoint_hardlink = path('forum_thread_view', {fid: entry.obj.forum.id, tid: entry.obj.id}) %}
        {% set message_type      = 'f' %}
    {% endif %}

    <li x-title="{{ message_title }}" x-domain="{{ message_type }}" x-identifier="{{ message_id }}"
        class="{% if entry.closed %}closed{% endif %} {% if entry.system %}system{% endif %} {% if entry.official %}og {% if entry.response is defined and entry.response %}responded{% endif %}{% endif %} {% if entry.unread > 0 %}new{% endif %}"
        {% if endpoint_hardlink is not null %}x-hardlink="{{ endpoint_hardlink }}"{% endif %}
            {% if endpoint_fetch  is not null %}x-endpoint="{{ endpoint_fetch }}"{% endif %}
            {% if endpoint_spring is not null %}x-spring="{{ endpoint_spring }}"{% endif %}
            {% if endpoint_answer is not null %}x-editor="{{ endpoint_answer }}"{% endif %}
            {% if endpoint_trash  is not null %}x-trash="{{ endpoint_trash }}"{% endif %}
            {% if endpoint_unread is not null %}x-unread="{{ endpoint_unread }}"{% endif %}
            {% if endpoint_archive is not null %}x-archive="{{ endpoint_archive }}"{% endif %}
            {% if endpoint_restore is not null %}x-restore="{{ endpoint_restore }}"{% endif %}
            {% if endpoint_pin is not null %}x-pin="{{ endpoint_pin }}"{% endif %}
            {% if endpoint_unpin is not null %}x-unpin="{{ endpoint_unpin }}"{% endif %}
            {% if endpoint_users  is not null %}x-userlist="{{ endpoint_users }}"{% endif %}
            {% if endpoint_block  is not null %}x-block="{{ endpoint_block }}"{% endif %}
            {% if endpoint_block_n is not null %}x-block-name="{{ endpoint_block_n }}"{% endif %}
    >
        {% if message_show_ava %}
            <div class="pm-avatar-block">
                {% if entry.system %}
                    {% include "ajax/soul/playeravatar.html.twig" with {user: 66, gpm: true} only %}
                {% elseif entry.official is not null and app.user in entry.users %}
                    {% include "ajax/soul/playeravatar.html.twig" with {user: entry.official, gpm: true} only %}
                {% elseif entry.users|length > 1 or entry.official is not null %}
                    {% set i = 0 %}
                    {% for message_partner in entry.users %}
                        {% if i < 4 and message_partner != app.user and message_partner != entry.owner and message_partner.avatar %}
                            {% include "ajax/soul/playeravatar.html.twig" with {user: message_partner, gpm: true} only %}
                            {% set i = i+1 %}
                        {% endif %}
                    {% endfor %}
                    {% if i < 4 %}
                        {% for message_partner in entry.users %}
                            {% if i < 4 and message_partner != app.user and message_partner != entry.owner and message_partner.avatar is empty %}
                                {% include "ajax/soul/playeravatar.html.twig" with {user: message_partner, gpm: true} only %}
                                {% set i = i+1 %}
                            {% endif %}
                        {% endfor %}
                    {% endif %}
                    {% if entry.owner is not empty and entry.owner != app.user %}
                        {% include "ajax/soul/playeravatar.html.twig" with {user: entry.owner, gpm: true, classes: ['owner']} only %}
                    {% endif %}
                {% endif %}
            </div>
        {% endif %}

        <b class="title {% if entry.system %}crow-note{% endif %}">{% if message_title_pre %}{{ message_title_pre }}<br />{% endif %}{{ entry.title }}</b>
        {% if entry.pinned > 0 %}<i class="fa fa-thumbtack"></i>{% endif %}
        {% if message_type == 'f' %}
            {% for message_partner in entry.users|filter(u => u != entry.owner) %}
                {% if loop.index0 < 5 %}
                    <span class="author group-desc"><b class="sender">{{ message_partner.name }}</b></span>{% if loop.index0 < 4 and not loop.last %}, {% endif %}
                {% elseif loop.index0 == 5 %}
                    <span class="author group-desc">{{ 'und andere.'|trans({},'global') }}</span>
                {% endif %}
            {% endfor %}
        {% elseif entry.system %}
            <span class="author crow-note">{{ 'Der Rabe'|trans({},'global') }}</span>
        {% elseif entry.official is not null and app.user not in entry.users %}
            {% if (entry.users|length < 5) %}
                {% for message_partner in entry.users %}
                    <span class="author group-desc"><b class="sender">{{ message_partner.name }}</b></span>
                {% endfor %}
            {% else %}
                <span class="author group-desc">{{ '{n} Teilnehmer'|trans({n: entry.users|length},'global') }}</span>
            {% endif %}
        {% elseif entry.official is not null %}
            <span class="author group-desc"><b class="sender" style="color: #ddab76">[ {{ entry.official.usergroup.name }} ]</b></span>
        {% elseif entry.users|length > 2 and entry.owner != app.user and not entry.owner is null %}
            <span class="author group-desc"><b class="sender">{{ entry.owner.name }}</b>, {{ '{n} Teilnehmer'|trans({'{n}': entry.users|length},'global') }}</span>
        {% elseif entry.users|length > 2 %}
            <span class="author group-desc">{{ '{n} Teilnehmer'|trans({'{n}': entry.users|length},'global') }}</span>
        {% elseif entry.users|length == 2 %}
            {% for message_partner in entry.users %}
                {% if message_partner != app.user %}
                    <span class="author group-desc"><b class="sender">{{ message_partner.name }}</b></span>
                {% endif %}
            {% endfor %}
        {% else %}
            <span class="author unknown"></span>
        {% endif %}

        {% if not entry.closed %}
            <span class="date">
                {% if entry.date >= 'today'|to_date %}
                    {{ 'Heute um'|trans({},'global') }} {{ entry.date|format_datetime('none', 'short') }}
                {% elseif entry.date >= 'yesterday'|to_date %}
                    {{ 'Gestern um'|trans({},'global') }} {{ entry.date|format_datetime('none', 'short') }}
                {% else %}
                    {{ entry.date|format_datetime('medium', 'short') }}
                {% endif %}
            </span>
        {% endif %}

        {% if entry.official is not null and app.user not in entry.users %}
            <span class="date">{{ 'via {group_inbox}'|trans({'{group_inbox}': '<span style="color: #ddab76">' ~ entry.official.usergroup.name ~ '</span>'},'global')|raw }}</span>
        {% endif %}
    </li>
{% endmacro %}
{% macro bubble_announcement(announcement, last) %}
    {# @var announcement App\Entity\Announcement #}
    <li x-domain="m-a" x-identifier="{{ announcement.id }}" x-announce-id="{{ announcement.id }}">
        <div class="pm-announce">
            <div class="pm-message-content">
                <h1>{{ announcement.title }}</h1>
                {{ announcement.text|replace({'{lang}': (app.request.locale|e('html_attr')|split('_', 2))[0] })|raw }}
            </div>
            <div class="pm-message-footer">
                {% include "ajax/soul/playeravatar.html.twig" with {user: announcement.sender, gpm: true} only %}
                <span class="pm-announcement-sender"><span class="hide-md">{% include 'ajax/soul/playername.html.twig' with {user: announcement.sender, plain: true} only %}</span></span>
                <span class="pm-announcement-date float-right">{% if announcement.timestamp >= "today"|to_date %}
                    {{ 'Heute um'|trans({},'global') }} {{ announcement.timestamp|format_datetime('none', 'short') }}
                {% elseif announcement.timestamp >= "yesterday"|to_date %}
                        {{ 'Gestern um'|trans({},'global') }} {{ announcement.timestamp|format_datetime('none', 'short') }}
                    {% else %}
                        {{ announcement.timestamp|format_datetime('medium', 'short') }}
                    {% endif %}</span>
            </div>
        </div>
    </li>
{% endmacro %}
{% macro bubble_dm(message, last) %}
    {# @var message App\Entity\GlobalPrivateMessage #}
    <li class="{% if not message.seen %}new{% endif %}" x-domain="m-g" x-identifier="{{ message.id }}">
        {% include "ajax/soul/playeravatar.html.twig" with {user: message.sender, gpm: true} only %}
        <div class="pm-message">
            <div class="pm-message-header">
                <img src="{{ asset('build/images/icons/small_user.gif') }}" alt="">
                {% include 'ajax/soul/playername.html.twig' with {user: message.sender} only %}
            </div>
            <div class="pm-message-content">
                <div class="crowmsg">{{ 'Dies ist eine offizielle Nachricht.'|trans({},'game') }} <a class="help-button"><div class="tooltip help">{{ 'Diese Nachricht wurde dir vom Raben persönlich überbracht. Er schwebt über der Stadt und wirft immer ein wachsames Auge auf dich...'|trans({},'global') }}</div>{{ 'Hilfe'|trans({},'global') }}</a></div>
                {{ message.text|replace({'{lang}': (app.request.locale|e('html_attr')|split('_', 2))[0] })|raw }}
            </div>
            <div class="pm-message-footer">
                {% if message.timestamp >= "today"|to_date %}
                    {{ 'Heute um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                {% elseif message.timestamp >= "yesterday"|to_date %}
                    {{ 'Gestern um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                {% else %}
                    {{ message.timestamp|format_datetime('medium', 'short') }}
                {% endif %}
            </div>
        </div>
    </li>
{% endmacro %}
{% macro bubble_group_pinned(message, last, group_owner = false) %}
    {# @var announcement App\Entity\Announcement #}
    <li x-domain="m-d" x-pinned x-identifier="{{ message.id }}">
        <div class="pm-announce">
            <div class="pm-message-content">
                {{ message.text|replace({'{lang}': (app.request.locale|e('html_attr')|split('_', 2))[0] })|raw }}
                {% if message.modMessage %}
                    <div class="modAnnounce">{{ message.modMessage }}</div>
                {% endif %}
                <div class="small right">
                    {% if group_owner %}
                        &nbsp;
                        <a class="pm-button pointer {% if message.pinned%}hidden{% endif %}" x-message-id="{{ message.id }}" x-pin-state="1" x-pin-url="{{ path('pm_pin_post_controller', {pid: message.id, action: 1}) }}">
                            <i class="fa fa-map-pin"></i><div class="tooltip forum-tooltip">{{'Anpinnen'|trans({}, 'global')}}</div>
                        </a>
                        <a class="pm-button pointer {% if not message.pinned%}hidden{% endif %}" x-message-id="{{ message.id }}" x-pin-state="0" x-pin-url="{{ path('pm_pin_post_controller', {pid: message.id, action: 0}) }}">
                            <i class="fa fa-times"></i><div class="tooltip forum-tooltip">{{'Pin entfernen'|trans({}, 'global')}}</div>
                        </a>
                    {% endif %}
                    {% if message.sender != app.user and message.senderGroup is empty %}
                        &nbsp;<a class="pm-button pointer" x-report-url="{{ path('pm_report_post_controller', {pid: message.id}) }}"><img alt="!" src="{{ asset('build/images/forum/warning.png') }}"><div class="tooltip forum-tooltip">{{'Unangemessene Nachricht blockieren'|trans({}, 'global')}}</div></a>
                    {% endif %}
                </div>
            </div>
            <div class="pm-message-footer">
                {% include "ajax/soul/playeravatar.html.twig" with {user: message.sender, gpm: true} only %}
                <span class="pm-announcement-sender"><span class="hide-md">{{ message.sender.name }}</span></span>
                <span class="pm-announcement-date right float-right">
                    <b>{{ 'Angepinnte Nachricht'|trans({},'global') }}</b><br />
                    {% if message.timestamp >= "today"|to_date %}
                        {{ 'Heute um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                    {% elseif message.timestamp >= "yesterday"|to_date %}
                        {{ 'Gestern um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                    {% else %}
                        {{ message.timestamp|format_datetime('medium', 'short') }}
                    {% endif %}
                </span>
            </div>
        </div>
    </li>
{% endmacro %}
{% macro bubble_group(message, last, group_owner = false) %}
    {# @var message App\Entity\GlobalPrivateMessage #}
    <li x-domain="m-d" x-identifier="{{ message.id }}" class="{% if message.sender == app.user %}own{% endif %} {% if message.id > last %}new{% endif %} {% if message.collapsed or (message.senderGroup is empty and app.user|related(message.sender,constant('App\\Entity\\SocialRelation::SocialRelationTypeBlock'))) %}collapsed{% endif %}">
        <div x-unveil="{{ message.id }}" class="unveil pointer"><i class="fa fa-eye-slash"></i> {{ 'Ausgeblendete Nachricht von {user}. Klicken, um anzuzeigen.'|trans({'{user}': '<strong>' ~ message.sender.name ~ '</strong>'}, 'global')|raw }}</div>
        {% include "ajax/soul/playeravatar.html.twig" with {
            user: (message.senderGroup and message.senderGroup.anon) ? message.senderGroup : message.sender,
            gpm: true
        } only %}
        <div class="pm-message">
            <div class="pm-message-header">
                {% if message.senderGroup and message.senderGroup.anon %}
                    <img src="{{ asset('build/images/icons/small_star.gif') }}" alt=""> <b style="color: #6298fc">[ {{ message.senderGroup.usergroup.name }} ]</b>
                    {% if is_granted('ROLE_ADMIN') %}
                        {% set playername %}{% include 'ajax/soul/playername.html.twig' with {user: message.sender} only %}{% endset %}
                        <i class="small">, {{ 'maskiert {playername}'|trans({playername: playername}, 'admin')|raw }}</i>
                    {% endif %}
                {% elseif message.senderGroup %}
                    <img src="{{ asset('build/images/icons/small_star.gif') }}" alt="">
                    {% include 'ajax/soul/playername.html.twig' with {user: message.sender} only %}
                    <b style="color: #6298fc">[ {{ message.senderGroup.usergroup.name }} ]</b>
                {% else %}
                    <img src="{{ asset('build/images/icons/small_user.gif') }}" alt="">
                    {% include 'ajax/soul/playername.html.twig' with {user: message.sender} only %}
                {% endif %}
            </div>
            <div class="pm-message-content">
                {% if message.hidden %}
                    <div class="crowmsg">{{ 'Der Rabe hat diese Nachricht zerrissen.'|trans({},'game') }}</div>
                {% else %}
                    {{ message.text|replace({'{lang}': (app.request.locale|e('html_attr')|split('_', 2))[0] })|raw }}
                {% endif %}
                {% if message.modMessage %}
                    <div class="modAnnounce">{{ message.modMessage }}</div>
                {% endif %}
            </div>
            <div class="pm-message-footer">
                {% if message.pinned %}
                    <b>[ {{ 'Angepinnte Nachricht'|trans({},'global') }} ]</b>
                {% endif %}

                {% if message.timestamp >= "today"|to_date %}
                    {{ 'Heute um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                {% elseif message.timestamp >= "yesterday"|to_date %}
                    {{ 'Gestern um'|trans({},'global') }} {{ message.timestamp|format_datetime('none', 'short') }}
                {% else %}
                    {{ message.timestamp|format_datetime('medium', 'short') }}
                {% endif %}
                {% if group_owner and not message.hidden %}
                    &nbsp;
                    <a class="pm-button {% if message.pinned%}hidden{% endif %}" x-message-id="{{ message.id }}" x-pin-state="1" x-pin-url="{{ path('pm_pin_post_controller', {pid: message.id, action: 1}) }}">
                        <i class="fa fa-map-pin"></i><div class="tooltip forum-tooltip">{{'Anpinnen'|trans({}, 'global')}}</div>
                    </a>
                    <a class="pm-button {% if not message.pinned%}hidden{% endif %}" x-message-id="{{ message.id }}" x-pin-state="0" x-pin-url="{{ path('pm_pin_post_controller', {pid: message.id, action: 0}) }}">
                        <i class="fa fa-times"></i><div class="tooltip forum-tooltip">{{'Pin entfernen'|trans({}, 'global')}}</div>
                    </a>
                    &nbsp;
                    <a class="pm-button {% if message.collapsed%}hidden{% endif %}" x-message-id="{{ message.id }}" x-collapse-state="1" x-collapse-url="{{ path('pm_collapse_post_controller', {pid: message.id, action: 1}) }}">
                        <i class="fa fa-eye-slash"></i><div class="tooltip forum-tooltip">{{'Ausblenden'|trans({}, 'global')}}</div>
                    </a>
                    <a class="pm-button {% if not message.collapsed%}hidden{% endif %}" x-message-id="{{ message.id }}" x-collapse-state="0" x-collapse-url="{{ path('pm_collapse_post_controller', {pid: message.id, action: 0}) }}">
                        <i class="fa fa-eye"></i><div class="tooltip forum-tooltip">{{'Einblenden'|trans({}, 'global')}}</div>
                    </a>
                {% endif %}
                {% if message.sender != app.user and message.senderGroup is empty and not message.hidden %}
                    &nbsp;<a class="pm-button" x-report-url="{{ path('pm_report_post_controller', {pid: message.id}) }}"><img alt="!" src="{{ asset('build/images/forum/warning.png') }}"><div class="tooltip forum-tooltip">{{'Unangemessene Nachricht blockieren'|trans({}, 'global')}}</div></a>
                {% endif %}
            </div>
        </div>
    </li>
{% endmacro %}
{% if raw_id is defined %}{% for index   in raw_id %}{{ _self.bubble_index(index)            }}{% endfor %}{% endif %}
{% if raw_gp is defined %}{% for message in raw_gp %}{{ _self.bubble_group(message,0,raw_gp_owner is defined ? raw_gp_owner : false) }}{% endfor %}{% endif %}
{% if raw_dm is defined %}{% for message in raw_dm %}{{ _self.bubble_dm(message,0)           }}{% endfor %}{% endif %}
{% if raw_an is defined %}{% for message in raw_an %}{{ _self.bubble_announcement(message,0) }}{% endfor %}{% endif %}